package org.jeecg.modules.ctop.controller;

import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.performance.entity.SalePerformanceDetail;
import org.jeecg.modules.performance.service.ISalePerformanceDetailService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * 销售绩效详细信息
 *
 * @author jeecg-boot
 * @version V1.0
 * @date 2020-04-01
 */
@Slf4j
@Api(tags = "销售绩效详细信息")
@RestController
@RequestMapping("/ctop/salePerformanceDetail")
public class SalePerformanceDetailController {
    @Autowired
    private ISalePerformanceDetailService salePerformanceDetailService;

    /**
     * 分页列表查询
     *
     * @param salePerformanceDetail
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    @ApiOperation(value = "销售绩效详细信息-分页列表查询", notes = "销售绩效详细信息-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<SalePerformanceDetail>> queryPageList(SalePerformanceDetail salePerformanceDetail,
                                                              @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                                              @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                                              HttpServletRequest req) {
        Result<IPage<SalePerformanceDetail>> result = new Result<>();
        QueryWrapper<SalePerformanceDetail> queryWrapper = QueryGenerator.initQueryWrapper(salePerformanceDetail, req.getParameterMap());
        Page<SalePerformanceDetail> page = new Page<>(pageNo, pageSize);
        IPage<SalePerformanceDetail> pageList = salePerformanceDetailService.page(page, queryWrapper);
        result.setSuccess(true);
        result.setResult(pageList);
        return result;
    }

    /**
     * 添加
     *
     * @param salePerformanceDetail
     * @return
     */
    @ApiOperation(value = "销售绩效详细信息-添加", notes = "销售绩效详细信息-添加")
    @PostMapping(value = "/add")
    public Result<SalePerformanceDetail> add(@RequestBody SalePerformanceDetail salePerformanceDetail) {
        Result<SalePerformanceDetail> result = new Result<>();
        try {
            salePerformanceDetailService.save(salePerformanceDetail);
            result.success("添加成功！");
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            result.error500("操作失败");
        }
        return result;
    }

    /**
     * 编辑
     *
     * @param salePerformanceDetail
     * @return
     */
    @ApiOperation(value = "销售绩效详细信息-编辑", notes = "销售绩效详细信息-编辑")
    @PutMapping(value = "/edit")
    public Result<SalePerformanceDetail> edit(@RequestBody SalePerformanceDetail salePerformanceDetail) {
        Result<SalePerformanceDetail> result = new Result<>();
        SalePerformanceDetail salePerformanceDetailEntity = salePerformanceDetailService.getById(salePerformanceDetail.getId());
        if (salePerformanceDetailEntity == null) {
            result.error500("未找到对应实体");
        } else {
            boolean ok = salePerformanceDetailService.updateById(salePerformanceDetail);
            if (ok) {
                result.success("修改成功!");
            }
        }

        return result;
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "销售绩效详细信息-通过id删除", notes = "销售绩效详细信息-通过id删除")
    @DeleteMapping(value = "/delete")
    public Result<Object> delete(@RequestParam(name = "id", required = true) String id) {
        try {
            salePerformanceDetailService.removeById(id);
        } catch (Exception e) {
            log.error("删除失败", e.getMessage());
            return Result.error("删除失败!");
        }
        return Result.ok("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @ApiOperation(value = "销售绩效详细信息-批量删除", notes = "销售绩效详细信息-批量删除")
    @DeleteMapping(value = "/deleteBatch")
    public Result<SalePerformanceDetail> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        Result<SalePerformanceDetail> result = new Result<>();
        if (ids == null || "".equals(ids.trim())) {
            result.error500("参数不识别！");
        } else {
            this.salePerformanceDetailService.removeByIds(Arrays.asList(ids.split(",")));
            result.success("删除成功!");
        }
        return result;
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    @ApiOperation(value = "销售绩效详细信息-通过id查询", notes = "销售绩效详细信息-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<SalePerformanceDetail> queryById(@RequestParam(name = "id", required = true) String id) {
        Result<SalePerformanceDetail> result = new Result<>();
        SalePerformanceDetail salePerformanceDetail = salePerformanceDetailService.getById(id);
        if (salePerformanceDetail == null) {
            result.error500("未找到对应实体");
        } else {
            result.setResult(salePerformanceDetail);
            result.setSuccess(true);
        }
        return result;
    }

    /**
     * 导出excel
     *
     * @param request
     * @param response
     */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
        QueryWrapper<SalePerformanceDetail> queryWrapper = null;
        try {
            String paramsStr = request.getParameter("paramsStr");
            if (oConvertUtils.isNotEmpty(paramsStr)) {
                String deString = URLDecoder.decode(paramsStr, "UTF-8");
                SalePerformanceDetail salePerformanceDetail = JSON.parseObject(deString, SalePerformanceDetail.class);
                queryWrapper = QueryGenerator.initQueryWrapper(salePerformanceDetail, request.getParameterMap());
            }
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }

        //Step.2 AutoPoi 导出Excel
        ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
        List<SalePerformanceDetail> pageList = salePerformanceDetailService.list(queryWrapper);
        //导出文件名称
        mv.addObject(NormalExcelConstants.FILE_NAME, "销售绩效详细信息列表");
        mv.addObject(NormalExcelConstants.CLASS, SalePerformanceDetail.class);
        mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("销售绩效详细信息列表数据", "导出人:Jeecg", "导出信息"));
        mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
        return mv;
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @PostMapping("/importExcel")
    public Result<Object> importExcel(HttpServletRequest request, HttpServletResponse response) {
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
        for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
            MultipartFile file = entity.getValue();
            ImportParams params = new ImportParams();
            params.setTitleRows(2);
            params.setHeadRows(1);
            params.setNeedSave(true);
            try {
                List<SalePerformanceDetail> listSalePerformanceDetails = ExcelImportUtil.importExcel(file.getInputStream(), SalePerformanceDetail.class, params);
                salePerformanceDetailService.saveBatch(listSalePerformanceDetails);
                return Result.ok("文件导入成功！数据行数:" + listSalePerformanceDetails.size());
            } catch (Exception e) {
                log.error(e.getMessage(), e);
                return Result.error("文件导入失败:" + e.getMessage());
            } finally {
                try {
                    file.getInputStream().close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }
        return Result.ok("文件导入失败！");
    }

}
